Type TServer
	As String nam,ip
	As String aliasname,ports(10)
	As Double pings(100)
	As String pingstime(100)
	As Integer pingtimer
	As Byte up,pinginterval
	Declare Sub Refresh()
	Declare Sub DrawWin(y As UShort)
	Declare Sub Ping()
End Type

Dim Shared As UByte server_anzahl
Dim Shared As String terminal

Sub TServer.Refresh()
	Dim As String lin
	Dim As UByte count
	Var ff=FreeFile
	Open Pipe "nslookup "+nam For Input As #ff
		Do Until Eof(ff)
			Line Input #ff,lin
			If Instr(lin,"Address: ") Then
				ip=Mid(lin,10)
			Elseif Instr(lin,"canonical name = ") Then
				aliasname=Mid(lin,Instr(lin,"canonical name = ")+17)
			End If
		Loop
	Close #ff
	
	ff=FreeFile
	Open Pipe "nmap "+nam For Input As #ff
		Do Until Eof(ff)
			Line Input #ff,lin
			If (Instr(lin,"/tcp") Or Instr(lin,"/udp")) And count<8 Then
				up=1
				count+=1
				If count<8 Then ports(count)=lin
			Elseif Instr(lin,"21/tcp    open   ftp") And count>=8 Then 
				ports(7)=lin
			ElseIf Instr(lin,"22/tcp    open   ssh") And count>=8 Then 
				ports(8)=lin
			Elseif Instr(lin,"Note: Host seems down.") Then
				up=0
			End If
		Loop
	Close #ff
End Sub

Sub TServer.Ping()
	Dim As String lin
	Dim As UByte count
	Var ff=FreeFile
	Open Pipe "ping "+nam+" -c 1" For Input As #ff
		Do Until Eof(ff)
			Line Input #ff,lin
			If Instr(lin,"time=") Then
				'pings(99)=pings(100)
				For i As Integer=1 To 99
					pings(i)=pings(i+1)
					pingstime(i)=pingstime(i+1)
				Next
				pings(100)=Val(Mid(lin,Instr(lin,"time=")+6,5))
				pingstime(100)=Time
			End If
		Loop
	Close #ff
End Sub

Sub TServer.DrawWin(y As UShort)
	Line (0,y+1)-(100,y+19),RGB(0,102,204),BF
	Line (120,y+1)-(230,y+19),RGB(0,102,204),BF
	Color RGB(245,255,255)
	Draw String (20,y+3),"Neuladen"
	Draw String (128,y+3),"Ping alle "+Str(pinginterval)+"s"
	If MouseX>20 And MouseX<100 And MouseY>y And MouseY<y+19 Then
		Line (0,y+1)-(100,y+19),RGB(245,255,255),BF
		Color RGB(1,1,1)
		Draw String (20,y+3),"Neuladen"
		If MouseB=1 And keytim<Timer-1 Then
			Refresh()
			keytim=Timer
		End If
	ElseIf MouseX>120 And MouseX<230 And MouseY>y And MouseY<y+19 Then
		Line (120,y+1)-(230,y+19),RGB(245,255,255),BF
		Color RGB(1,1,1)
		Draw String (128,y+3),"Ping alle "+Str(pinginterval)+"s"
		If MouseB=1 And keytim<Timer-0.25 Then
			pinginterval+=1
			If pinginterval>10 Then pinginterval=1
			keytim=Timer
		End If
	End If
	Color RGB(245,255,255)
	Draw String (10,y+20),"Name:  "+nam
	Draw String (10,y+35),"Alias: "+aliasname
	Draw String (10,y+50),"IP:    "+IP
	Line (0,y+65)-(400,y+65),RGB(136,139,139)
	Draw String (10,y+67),"NMAP:"
	For i As Integer=1 To 9
		Color RGB(245,255,255)
		If ports(i)<>"" Then Draw String (70,y+52+i*15),ports(i)
		If Instr(ports(i),"21/tcp    open   ftp") Then 
			Line (300,y+52+i*15)-(390,y+65+i*15),RGB(0,102,204),BF
			Color RGB(245,255,255)
			Draw String (306,y+52+i*15),"FTP-Client"
			If MouseX>300 And MouseX<390 And MouseY>y+52+i*15 And MouseY<y+66+i*15 Then
				Line (300,y+52+i*15)-(390,y+66+i*15),RGB(245,255,255),BF	
				Color RGB(1,1,1)
				Draw String (306,y+52+i*15),"FTP-Client"
				If MouseB=1 And keytim<Timer-1 Then
					Shell (terminal+" "+Chr(34)+"ftp -nv "+nam+Chr(34))
					keytim=Timer
				End If
			End If
		End If
		If Instr(ports(i),"22/tcp    open   ssh") Then 
			Line (300,y+52+i*15)-(390,y+66+i*15),RGB(0,102,204),BF
			Color RGB(245,255,255)
			Draw String (306,y+52+i*15),"SSH-Client"
			If MouseX>300 And MouseX<390 And MouseY>y+52+i*15 And MouseY<y+66+i*15 Then
				Line (300,y+52+i*15)-(390,y+66+i*15),RGB(245,255,255),BF	
				Color RGB(1,1,1)
				Draw String (306,y+52+i*15),"SSH-Client"
				If MouseB=1 And keytim<Timer-1 Then
					Shell (terminal+" "+Chr(34)+"ssh -X root@"+nam+Chr(34))
					keytim=Timer
				End If
			End If
		End If
	Next
	If up=0 Then Color RGB(224,108,117):Draw String (70,y+67),"Host nicht erreichbar"
	
	Line (0,y-3)-(Xmax,y-3),RGB(136,139,139)
	Line (0,y)-(Xmax,y),RGB(136,139,139)
	Line (400,y)-(400,y+197),RGB(136,139,139)
	
	' ############# PING ############
	
	Line (401,y+1)-(Xmax,y+196),RGB(255,255,255),BF
	If pingtimer<Timer-pinginterval And up=1 Then Ping():pingtimer=Timer
	
	Dim As Double multi
	multi=0
	For i As Integer=1 To 100
		If pings(i)>multi Then multi=pings(i)
	Next
	Color RGB(0,0,0)
	Draw String (405,y+182),"0 ms"
	Draw String (405,y+2),Format(multi,"0.#")+" ms"
	multi=190/multi
	Line (401,y+196-pings(100)*multi)-(800,y+196-pings(100)*multi),RGB(136,139,139),,&hFF00
	Draw String (735,y+196-pings(100)*multi),Format(pings(100),"0.##")+" ms"
	
	For i As Integer=2 To 100
		If pings(i)<=0 Or pings(i)>20 Then
			Line (450+i*3,y+196-pings(i)*multi)-(450+(i-1)*3,y+196-pings(i-1)*multi),RGB(200,0,0)
		Else
			Line (450+i*3,y+196-pings(i)*multi)-(450+(i-1)*3,y+196-pings(i-1)*multi),RGB(0,200,0)
		End If
	Next
	
	For i As Integer=2 To 100
		If MouseY>y And MouseY<y+200 Then
			If MouseX>450+i*3-2 And MouseX<450+i*3+2 And pings(i)<>0 Then
				Line (450+i*3,y)-(450+i*3,y+196),RGB(136,139,139)
				Line (MouseX+10,MouseY-2)-(MouseX+14+Len(pingstime(i))*8,MouseY+30),RGB(136,139,139),BF
				Color RGB(1,1,1)
				Draw String (MouseX+12,MouseY),Format(pings(i),"0.##")+" ms"
				Draw String (MouseX+12,MouseY+15),pingstime(i)
			End If
		End If
	Next
End Sub

Dim Shared As TServer Server(5)

Sub AddServer(nam As String)
	With Server(server_anzahl)
		.nam=nam
		.Refresh()
		.pingtimer=server_anzahl
		.pinginterval=2
	End With
	server_anzahl+=1
End Sub

'Var ff=FreeFile
'Dim As String lin
'Open "serverlist.cfg" For Input As #ff
	'Do Until Eof(ff)
		'Line Input #ff,lin
		'If Instr (lin,"#") Then
		
		'Else
			'AddServer(lin)
		'End If
	'Loop
'Close #ff

Var ff=FreeFile
Dim As String lin
Open "server-test.cfg" For Input As #ff
	Line Input #ff,terminal
	terminal=Mid(terminal,10)
	Do Until Eof(ff)
		Line Input #ff,lin
		If Instr (lin,"#") Then
			
		Else
			AddServer(lin)
		End If
	Loop
Close #ff

